defmodule CobblemonUi.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    children = [
      CobblemonUiWeb.Telemetry,
      {DNSCluster, query: Application.get_env(:cobblemon_ui, :dns_cluster_query) || :ignore},
      {Phoenix.PubSub, name: CobblemonUi.PubSub},
      # Start a worker by calling: CobblemonUi.Worker.start_link(arg)
      # {CobblemonUi.Worker, arg},
      # Start to serve requests, typically the last entry
      CobblemonUiWeb.Endpoint
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: CobblemonUi.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    CobblemonUiWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
